unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls;

type

  TRaceThread = class (TThread)
  private
   vx,vy,x,y,speed:integer;
   color:TColor;
   function outofbounds(x,y:integer):boolean;
  public
    constructor create(suspended:boolean;color:TColor);
    procedure execute;override;
    procedure move;
    procedure show;
    procedure hide;
  end;


  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Race1: TMenuItem;
    Start1: TMenuItem;
    Exit1: TMenuItem;
    Image1: TImage;
    procedure Start1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
     run:boolean;
     racers:array of TRaceThread;
    { Private declarations }
  public
     function canRun:boolean;
     procedure stop;
    { Public declarations }
  end;



var
  Form1: TForm1;

implementation
 constructor TRaceThread.create(suspended:boolean;color:TColor);
 begin
  inherited create(suspended);
  self.color := color;
  speed:=random(250)+50;
  vx:=random(11)-5;
  vy:=random(11)-5;
  x:=Form1.Image1.Width div 2;
  y:=Form1.Image1.Height div 2;
 end;

  procedure TRaceThread.execute;
  var run:boolean;
  begin
    repeat
      run:=form1.canRun;
      if run then
      begin
       sleep(speed);
       Synchronize(move);
       vx:=vx+random(5)-2;
       vy:=vy+random(5)-2;
       if outofbounds(x,y) then
       begin
        synchronize(form1.stop);
        run := false;
       end;
      end;
    until not run;
  end;

  function TRaceThread.outOfBounds(x,y:integer):boolean;
  begin
   outOfBounds:= (x<=0) or (y<=0)
       or (x>=Form1.Image1.Width) or(y>=Form1.Image1.Height);
  end;

  procedure TRaceThread.show;
  begin
   form1.Image1.Canvas.Pen.Color:=color;
   form1.Image1.Canvas.Brush.Color:=color;
   Form1.Image1.Canvas.Ellipse(x-5,y-5,x+5,y+5);
  end;


  procedure TRaceThread.move;
  begin
   hide;
   x:=x+vx;
   y:=y+vy;
   show;
  end;

  procedure TRaceThread.hide;
  begin
   Form1.Image1.Canvas.Pen.Color:=clWhite;
   Form1.Image1.Canvas.Brush.Color:=clWhite;
   Form1.Image1.Canvas.Ellipse(x-5,y-5,x+5,y+5);
  end;

  function TForm1.canRun:boolean;
  begin
   canRun := run;
  end;

  procedure TForm1.stop;
  begin
   run:=false;
   start1.Enabled:=true;
  end;

{$R *.dfm}

procedure TForm1.Start1Click(Sender: TObject);
var i:integer;
    count:integer;
begin
 count:=random(6)+2;
 Start1.Enabled:=false;
 setLength(racers,count);
 run:=true;
 Image1.Canvas.Pen.Color:=clWhite;;
 Image1.Canvas.Brush.Color:=clWhite;
 Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
 for i := 0 to length(racers) -1 do
  racers[i]:=TRaceThread.create(true,i*16000);
 for i:= 0 to length(racers)-1 do
  racers[i].Resume;
end;

procedure TForm1.Exit1Click(Sender: TObject);
var i:integer;
begin
 run:=false;
 application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 randomize;
 Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
end;

end.


